#include "GUI.h"
#include "WM.h"
#include "DIALOG.h"
#include "math.h"
#include "stdio.h"
#include "stdlib.h"
#include "N9H20.h"
#include "SmartPlug_Global.h"

#define AA_Factor 3
#define ID_WINDOW_0 (GUI_ID_USER + 0x00)
#define ID_BUTTON_0 (GUI_ID_USER + 0x01)
#define ID_BUTTON_1 (GUI_ID_USER + 0x02)
#define ID_BUTTON_2 (GUI_ID_USER + 0x03)
#define ID_BUTTON_3 (GUI_ID_USER + 0x04)
#define ID_BUTTON_4 (GUI_ID_USER + 0x05)
#define ID_BUTTON_5 (GUI_ID_USER + 0x06)
#define ID_TIMER_0  (GUI_ID_USER + 0x07)
#define x0 240
#define y0 115
#define Round_rad 60
#define Arc_dregreeS -37
#define Arc_dregreeE 217
#define Rad_Range 10
#define FadeButtonX0 60
#define FadeButtonY0 12
#define FadeButtonX0_Size 20
#define FadeButtonY0_Size 192
#define FadeLevel 16
WM_HWIN Create_ICON_Window(void);
volatile int WGTouchStatus;
extern volatile int Icon_Idex, Window_Idex;
extern volatile float Draw_degree;
extern volatile int DALI_PowerSW, DALI_DeviceStatus, DALI_PowerStatus;
extern volatile int DALI_FadeLevel;

extern GUI_CONST_STORAGE GUI_BITMAP bmDali_add26x26;
extern GUI_CONST_STORAGE GUI_BITMAP bmDali_desktop320x240;  
extern GUI_CONST_STORAGE GUI_BITMAP bmDali_reduce26x26;  
extern GUI_CONST_STORAGE GUI_BITMAP bmhome32x32;
extern GUI_CONST_STORAGE GUI_BITMAP bmDaliStart42x42;
extern GUI_CONST_STORAGE GUI_BITMAP bmDaliStop42x42;

static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = {
  { WINDOW_CreateIndirect, "Window", ID_WINDOW_0, 0, 0, 320, 240, 0, 0x0, 0 },
//  { BUTTON_CreateIndirect, "ReturnButton", ID_BUTTON_0, 270, 195, 32, 32, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "ReturnButton", ID_BUTTON_0, 285, 205, 32, 32, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "ArcButton", ID_BUTTON_1, 170, 50, 140, 105, 0, 0x0, 0 },
//  { BUTTON_CreateIndirect, "LightSwitch", ID_BUTTON_2, 144, 195, 32, 32, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "LightSwitch", ID_BUTTON_2, 135, 190, 42, 42, 0, 0x0, 0 },
//  { BUTTON_CreateIndirect, "LeftButton", ID_BUTTON_3, 200, 165, 24, 24, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "LeftButton", ID_BUTTON_3, 200, 165, 26, 26, 0, 0x0, 0 },
//  { BUTTON_CreateIndirect, "RightButton", ID_BUTTON_4, 260, 165, 24, 24, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "RightButton", ID_BUTTON_4, 260, 165, 26, 26, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "FadeButton", ID_BUTTON_5, FadeButtonX0, FadeButtonY0, FadeButtonX0_Size, FadeButtonY0_Size, 0, 0x0, 0 },
};

void Show_TEXT(void)
{
    char ac[1];
    GUI_SetColor(GUI_CYAN);
    GUI_DispStringHCenterAt("DALI Status" , 280, 35);

    
    GUI_SetFont(&GUI_Font16B_ASCII);
    GUI_SetTextMode(GUI_TM_TRANS);
    GUI_SetTextAlign(GUI_TA_HCENTER | GUI_TA_VCENTER);
//    GUI_SetColor(GUI_RED);
    GUI_SetColor(GUI_BLACK);
//    GUI_DispStringHCenterAt("DALI Page" , 160, 15);
    GUI_DispStringHCenterAt("DALI Lighting" , 160, 15);
    sprintf(ac, "%d", (int)(Draw_degree+abs(Arc_dregreeS)));
    GUI_DispStringHCenterAt(ac , 240, 125);  
//    GUI_SetColor(GUI_BROWN); 
//    GUI_DispStringHCenterAt("Fade time" , 70, 220);
    GUI_DispStringHCenterAt("Fade Out Time" , 70, 220);
//    GUI_DispStringHCenterAt("DAPC" , 243, 185);
    GUI_DispStringHCenterAt("Brightness" , 243, 197);
}

void Draw_DALIStatus(void)
{
    GUI_AA_EnableHiRes(); /* Enable high resolution */
    GUI_AA_SetFactor(AA_Factor); /* Set quality factor */
    if(DALI_DeviceStatus)
        GUI_SetColor( GUI_DARKGREEN );
    else
        GUI_SetColor( GUI_RED );
    GUI_AA_FillCircle(280*AA_Factor, 20*AA_Factor, 10*AA_Factor);
    GUI_AA_DisableHiRes(); /* Disable high resolution */
}

void Draw_FadeTime(void)
{
    int i;
    char ac[FadeLevel];
    GUI_AA_EnableHiRes(); /* Enable high resolution */
    GUI_AA_SetFactor(AA_Factor); /* Set quality factor */
    GUI_SetColor( GUI_GRAY );
//    GUI_AA_FillRoundedRect(45*AA_Factor, 40*AA_Factor, 65*AA_Factor, 200*AA_Factor, 0);
    GUI_AA_FillRoundedRect(FadeButtonX0*AA_Factor, (FadeButtonY0+(FadeButtonY0_Size/FadeLevel))*AA_Factor, (FadeButtonX0+FadeButtonX0_Size)*AA_Factor, (FadeButtonY0+FadeButtonY0_Size)*AA_Factor, 0);
    GUI_SetPenSize( 2 );
    GUI_SetColor( GUI_BLACK );
    GUI_SetTextMode(GUI_TM_TRANS);
    for(i=0; i<FadeLevel; i++)
    {
//        GUI_AA_DrawLine(40*AA_Factor, (40+i*10)*AA_Factor, 50*AA_Factor, (40+i*10)*AA_Factor);
//        GUI_AA_DrawLine(40*AA_Factor, (24+i*12)*AA_Factor, 50*AA_Factor, (24+i*12)*AA_Factor);
        GUI_AA_DrawLine((FadeButtonX0-5)*AA_Factor, (((FadeButtonY0+FadeButtonY0_Size)-(i*(FadeButtonY0_Size/FadeLevel))))*AA_Factor, (FadeButtonX0+5)*AA_Factor, (((FadeButtonY0+FadeButtonY0_Size)-(i*(FadeButtonY0_Size/FadeLevel))))*AA_Factor);
        sprintf(ac, "%d", i);
//        GUI_DispStringHCenterAt(ac , 30, (35+i*10));
        GUI_DispStringHCenterAt(ac , (FadeButtonX0-15), ((FadeButtonY0+FadeButtonY0_Size-5)-(i*(FadeButtonY0_Size/FadeLevel))));
    }
    GUI_SetColor( GUI_BLUE );
    GUI_AA_FillRoundedRect(FadeButtonX0*AA_Factor, ((FadeButtonY0+FadeButtonY0_Size)-(DALI_FadeLevel*(FadeButtonY0_Size/FadeLevel)))*AA_Factor, (FadeButtonX0+FadeButtonX0_Size)*AA_Factor, (FadeButtonY0+FadeButtonY0_Size)*AA_Factor, 0);
    GUI_AA_DisableHiRes(); /* Disable high resolution */
}

void Draw_Arc(void)
{    
    int x1, y1, i;
    double a;
    GUI_AA_EnableHiRes(); /* Enable high resolution */
    GUI_AA_SetFactor(AA_Factor); /* Set quality factor */
    
    GUI_SetColor( GUI_LIGHTGRAY );
    GUI_AA_FillCircle(x0*AA_Factor, y0*AA_Factor, Round_rad*AA_Factor);
    
    GUI_SetPenSize( 10 );
    GUI_SetColor( GUI_GRAY );
    //GUI_DrawArc( x0, y0, Round_rad, Round_rad, Arc_dregreeS, Arc_dregreeE);
    GUI_AA_DrawArc(x0*AA_Factor, y0*AA_Factor, Round_rad*AA_Factor, Round_rad*AA_Factor, Arc_dregreeS, Arc_dregreeE);

    GUI_SetColor( GUI_BLUE );
    //GUI_DrawArc( x0, y0, Round_rad, Round_rad, Arc_dregreeS, Draw_degree); 
    GUI_AA_DrawArc(x0*AA_Factor, y0*AA_Factor, Round_rad*AA_Factor, Round_rad*AA_Factor, Arc_dregreeS, Draw_degree);

    GUI_SetColor( GUI_RED );
    for (i=0; i< 22; i++)
    {
        a = ((i*12) + Arc_dregreeS )*3.1415926/180;
        x1 = -54*cos(a)+x0;
        y1 = -54*sin(a)+y0;
//        GUI_SetPenSize( 5 );
//        GUI_DrawPoint(x1,y1);
        GUI_AA_FillCircle(x1*AA_Factor, y1*AA_Factor, 2*AA_Factor);
    }
    GUI_AA_DisableHiRes(); /* Disable high resolution */
    
//    GUI_SetPenSize( 5 );
//    GUI_DrawPoint(170,50);    
//    GUI_DrawPoint(170+140,50);
//    GUI_DrawPoint(170,50+105);
//    GUI_DrawPoint(170+140,50+105);
//    GUI_SetColor( GUI_BLUE );
//    GUI_DrawPoint(165,45+145);
//    GUI_DrawPoint(165+145,45+145); 
//    GUI_DrawPoint(170,45);  
//    GUI_DrawPoint(170+140,45);    
}

static void _cbButton0(WM_MESSAGE * pMsg) 
{
     switch(pMsg->MsgId)
     {
         case WM_PAINT:
             GUI_DrawBitmap(&bmhome32x32,0,0);     
              break;
         default:
              BUTTON_Callback(pMsg);
     }
}

static void _cbButton1(WM_MESSAGE * pMsg)
{
     switch(pMsg->MsgId)
     {
         case WM_PAINT:
              GUI_SetAlpha(0xaf);
              break;
         default:
              BUTTON_Callback(pMsg);
     }
}

static void _cbButton2(WM_MESSAGE * pMsg) 
{
     switch(pMsg->MsgId)
     {
         case WM_PAINT:
             GUI_SetAlpha(0xff);
             if(DALI_PowerSW)
             {
                 GUI_DrawBitmap(&bmDaliStop42x42,0,0);
             }
             else  
             {
                 GUI_DrawBitmap(&bmDaliStart42x42,0,0);
             }                 
              break;
         default:
              BUTTON_Callback(pMsg);
     }
}

static void _cbButton3(WM_MESSAGE * pMsg) 
{
     switch(pMsg->MsgId)
     {
         case WM_PAINT:
             GUI_DrawBitmap(&bmDali_add26x26,0,0);     
              break;
         default:
              BUTTON_Callback(pMsg);
     }
}

static void _cbButton4(WM_MESSAGE * pMsg) 
{
     switch(pMsg->MsgId)
     {
         case WM_PAINT:
             GUI_DrawBitmap(&bmDali_reduce26x26,0,0);     
              break;
         default:
              BUTTON_Callback(pMsg);
     }
}

static void _cbButton5(WM_MESSAGE * pMsg)
{
     switch(pMsg->MsgId)
     {
         case WM_PAINT:
              GUI_SetAlpha(0xaf);
              break;
         default:
              BUTTON_Callback(pMsg);
     }
}

static void _cbDALI(WM_MESSAGE * pMsg) {
    WM_HWIN hItem, hWin;
    GUI_PID_STATE TouchState;
    static volatile double  a, x_axis, y_axis, touch_NowX, touch_NowY, touch_rad;
    int     NCode;
    int     Id;
    int     LeftB_flag=0, RightB_flag=0;

    hWin = pMsg->hWin;
    switch (pMsg->MsgId) {
    case WM_INIT_DIALOG:

        hItem = WM_GetDialogItem(pMsg->hWin, ID_BUTTON_0);            
        WM_SetCallback(hItem,_cbButton0);     
    
        hItem = WM_GetDialogItem(pMsg->hWin, ID_BUTTON_1);
        WM_SetHasTrans(hItem);             
        WM_SetCallback(hItem,_cbButton1);  
        GUI_SetAlpha(0xff);
    
        hItem = WM_GetDialogItem(pMsg->hWin, ID_BUTTON_2);            
        WM_SetCallback(hItem,_cbButton2);
    
        hItem = WM_GetDialogItem(pMsg->hWin, ID_BUTTON_3);
        WM_SetCallback(hItem,_cbButton3);
    
        hItem = WM_GetDialogItem(pMsg->hWin, ID_BUTTON_4);
        WM_SetCallback(hItem,_cbButton4);
        
        hItem = WM_GetDialogItem(pMsg->hWin, ID_BUTTON_5);
        WM_SetHasTrans(hItem);             
        WM_SetCallback(hItem,_cbButton5);  
        GUI_SetAlpha(0xff);    
        
        WM_CreateTimer(pMsg->hWin, ID_TIMER_0, 500, 0);
    break;

    case WM_PAINT:
        GUI_SetBkColor(GUI_ORANGE);
        GUI_Clear(); 
//        GUI_DrawBitmap(&bmIndonesia140x140,170 ,45);
        //GUI_DrawBitmap(&bmIndonesia140x140,10 ,45);
        GUI_DrawBitmap(&bmDali_desktop320x240,0 ,0);
        Draw_Arc();
        Draw_FadeTime();
        Draw_DALIStatus();
        Show_TEXT();
    break;

    case WM_TIMER:
        if(DALI_PowerSW)
        {
            DALI_PowerStatus=1;
        }
        WM_InvalidateWindow(pMsg->hWin);            
        WM_RestartTimer(pMsg->Data.v, 500);
    break;  
    
    case WM_NOTIFY_PARENT:
        Id    = WM_GetId(pMsg->hWinSrc);
        NCode = pMsg->Data.v;
        switch(Id) {
        case ID_BUTTON_0: // Notifications sent by 'Button'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                //__nop();
            break;
            case WM_NOTIFICATION_RELEASED:
                WM_DeleteWindow(hWin);
                Create_ICON_Window();
            break;
            }
        break;
            
            
        case ID_BUTTON_1: // Notifications sent by 'Button'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                WGTouchStatus = 1;
//                //__nop();
            break;
            case WM_NOTIFICATION_RELEASED:
                WGTouchStatus = 0;
                if((LeftB_flag!=1) && (RightB_flag!=1))
                {
                    GUI_TOUCH_GetState(&TouchState);  // Get the touch position in pixel
                    touch_NowX=TouchState.x;
                    touch_NowY=TouchState.y;
                    if(x0 >= touch_NowX)      x_axis = x0-touch_NowX;
                    else                      x_axis = touch_NowX-x0;
                    if(y0 >= touch_NowY)      y_axis = y0-touch_NowY;
                    else                      y_axis = touch_NowY-y0; 
                    touch_rad = sqrt(((x_axis * x_axis) + (y_axis * y_axis)));            
                    if((touch_rad >= (Round_rad-Rad_Range)) && (touch_rad <= (Round_rad+Rad_Range)))
                    {
                        a = acos((double)((touch_NowX - x0)/touch_rad));
                        if(touch_NowY - y0 > 0)
                        {
                            Draw_degree = (a* (180.0/3.1415926));
                            Draw_degree = (((180-Draw_degree)*2)+Draw_degree);
                            if(Draw_degree>=Arc_dregreeE && Draw_degree<=270) Draw_degree = Arc_dregreeE;
                            else if(Draw_degree>270 && Draw_degree<=360)
                            {
                                Draw_degree = Draw_degree - 360;
                                if(Draw_degree<=Arc_dregreeS) Draw_degree = Arc_dregreeS;
                            }                            
                        }
                        else
                        {
                            Draw_degree = (a* (180.0/3.1415926));
                        }
                        WM_InvalidateWindow(pMsg->hWin);
                    }                    
                }            
            break;
            }
        break;
            
        case ID_BUTTON_2: // Notifications sent by 'Button'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                //__nop();
            break;
            case WM_NOTIFICATION_RELEASED:
//                if(DALI_DeviceStatus)
//                {
                    DALI_PowerSW^=1;
//                    if(DALI_PowerSW)
//                        DALI_LED =LED_ON;
//                    else
//                        DALI_LED =LED_OFF; 
                    DALI_PowerStatus=1;
                    DALI_DeviceStatus = 1;
                    WM_InvalidateWindow(pMsg->hWin);                    
//                }
            break;
            }            
        break;
            
        case ID_BUTTON_3: // Notifications sent by 'Button'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                WGTouchStatus = 1;
//                //__nop();
            break;
            case WM_NOTIFICATION_RELEASED:
                WGTouchStatus = 0;
                Draw_degree+=1;
                if(Draw_degree>=Arc_dregreeE) Draw_degree=Arc_dregreeE;
                WM_InvalidateWindow(pMsg->hWin);  
                LeftB_flag=1;                    
            break;
            }            
        break;

        case ID_BUTTON_4: // Notifications sent by 'Button'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                WGTouchStatus = 1;
//                //__nop();
            break;
            case WM_NOTIFICATION_RELEASED:
                WGTouchStatus = 0;
                Draw_degree-=1;
                if(Draw_degree<=Arc_dregreeS)Draw_degree=Arc_dregreeS;
                WM_InvalidateWindow(pMsg->hWin);
                RightB_flag=1;
            break;
            }            
        break; 

        case ID_BUTTON_5: // Notifications sent by 'Button'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                WGTouchStatus = 1;
//                //__nop();
            break;
            case WM_NOTIFICATION_RELEASED:
                WGTouchStatus = 0;
                GUI_TOUCH_GetState(&TouchState);  // Get the touch position in pixel
                DALI_FadeLevel = (((FadeButtonY0_Size+FadeButtonY0)/(FadeButtonY0_Size/FadeLevel))-1) - (TouchState.y/(FadeButtonY0_Size/FadeLevel));
                if(DALI_FadeLevel>(FadeLevel-1)) DALI_FadeLevel = (FadeLevel-1);
                WM_InvalidateWindow(pMsg->hWin);
            break;
            }            
        break;            
    }
    LeftB_flag=0; 
    RightB_flag=0;
    break;
    default:
        WM_DefaultProc(pMsg);
    break;
    }
}

void Create_DALIWindow(void)
{
    Icon_Idex = 1;
    Window_Idex = DALI_WINDOW;
	GUI_CreateDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), _cbDALI, WM_HBKWIN, 0, 0);
}
