#include "N9H20.h"
#include "DIALOG.h"
#include "stdio.h"
#include "math.h"
#include "SmartPlug_Global.h"
#define ID_WINDOW_0    (GUI_ID_USER + 0x00)
#define ID_MULTIPAGE_0 (GUI_ID_USER + 0x02)

#define ID_Muti_WINDOW_10 (GUI_ID_USER + 0x10)
#define ID_Muti_BUTTON_10 (GUI_ID_USER + 0x11)
#define ID_Muti_TIMER_10  (GUI_ID_USER + 0x13)

#define ID_Muti_WINDOW_20 (GUI_ID_USER + 0x20)
#define ID_Muti_BUTTON_20 (GUI_ID_USER + 0x21)
#define ID_Muti_BUTTON_21 (GUI_ID_USER + 0x22)
#define ID_Muti_LISTWHEEL_20 (GUI_ID_USER + 0x23)
#define ID_Muti_LISTWHEEL_21 (GUI_ID_USER + 0x24)
#define ID_Muti_TIMER_20  (GUI_ID_USER + 0x25)
#define ListWheel_0X0 130
#define ListWheel_0Y0 25
#define ListWheel_1X0 (ListWheel_0X0+ListWheelX0_Size)+(WheelText_Gap0*2)
#define ListWheel_1Y0 25
#define ListWheelX0_Size 40
#define ListWheelY0_Size 150
#define Wheel_LineHeight 30
#define WheelText_Gap0 30
#define WheelText_Gap1 20

#define ID_Muti_WINDOW_30 (GUI_ID_USER + 0x30)
#define ID_Muti_BUTTON_30 (GUI_ID_USER + 0x31)
#define ID_Muti_TIMER_30  (GUI_ID_USER + 0x33)
#define AA_Factor 3
#define SpeedMeterX0 160
#define SpeedMeterY0 130
#define SpeedMeter_rad 120
#define Meter_dregreeS -30
#define Meter_dregreeE 210
#define Meter_Line_X0Y0   -(SpeedMeter_rad-40)
#define Meter_TextNumX0   -(SpeedMeter_rad-30)
#define Meter_TextNumY0   -(SpeedMeter_rad-20)
#define Meter_Point_X0Y0  -(SpeedMeter_rad-10)

#define DC3_Muti1_TimerDelay  500
WM_HWIN Create_PowerWindow(void);
WM_HWIN DC3Multi_hWin;

extern volatile int Window_Idex;
extern volatile float DC3_Acc_Currnet, DC3_Currnet;
extern volatile int DC3_PowerSW, DC3_PowerStatus;
extern volatile int DC3_SpeedMeterValue;
extern volatile int DC3_ListWheel1_Hr, DC3_ListWheel2_Min, DC3_BackUp_ListWheel1Hr, DC3_BackUp_ListWheel2Min;       
extern volatile int DC3_RTC_BaseHr, DC3_RTC_BaseMin, DC3_RTC_ConHr, DC3_RTC_ConMin;
extern volatile int DC3_CurrnetUnit, DC3_ConsumpUnit, DC3_Muti1GetInfo;
extern volatile int DC3_Muti_Idex;

extern GUI_CONST_STORAGE GUI_BITMAP bmPower_desktop320x240;  
extern GUI_CONST_STORAGE GUI_BITMAP bmhome32x32;
extern GUI_CONST_STORAGE GUI_BITMAP bmPowerStart48x48;
extern GUI_CONST_STORAGE GUI_BITMAP bmPowerStop48x48;

/*************************** Multi Page1 ****************************/
static const GUI_WIDGET_CREATE_INFO _aDialogCreateDC3MPage1[] = {
  { WINDOW_CreateIndirect, "Window", ID_Muti_WINDOW_10, 0, 0, 320, 210, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "ReturnButton", ID_Muti_BUTTON_10, 285, 175, 32, 32, 0, 0x0, 0 },
};

void DC3Show_Muti1_TEXT(void)
{
    char ac[10];
    
    GUI_SetTextMode(GUI_TM_TRANS);
    GUI_SetTextAlign(GUI_TA_HCENTER | GUI_TA_VCENTER);
    
    GUI_SetFont(GUI_FONT_20B_1);
    GUI_SetColor(GUI_RED);
    GUI_DispStringHCenterAt("DC3" , 30, 20);
    
    GUI_SetFont(GUI_FONT_24B_1);
    GUI_SetColor(GUI_WHITE);
    GUI_DispStringHCenterAt("USAGE TIME" , 100, 80);
    GUI_DispStringHCenterAt("CONSUMPTION" , 100, 130);
    
    GUI_SetFont(GUI_FONT_20B_1);
    GUI_SetColor(GUI_YELLOW);
    if(DC3_PowerSW)
    {
        sprintf(ac,"%02d:%02d", DC3_RTC_ConHr, DC3_RTC_ConMin);
    }
    else
    {
        sprintf(ac,"%02d:%02d", DC3_BackUp_ListWheel1Hr, DC3_BackUp_ListWheel2Min);
    }
    GUI_DispStringHCenterAt(ac , 220, 80);

    sprintf(ac,"%.2f", DC3_Acc_Currnet);
    GUI_DispStringHCenterAt(ac , 220, 130);
    if (DC3_ConsumpUnit == 0x00)
    {                     
        GUI_DispStringHCenterAt("mWHr" , 280, 130);
    }     
    else if (DC3_ConsumpUnit == 0x01)
    {                      
        GUI_DispStringHCenterAt("WHr" , 280, 130);
    }    
    else if (DC3_ConsumpUnit == 0x02)
    {                      
        GUI_DispStringHCenterAt("KWHr" , 280, 130);
    }     
}

static void _cbMutiButton10(WM_MESSAGE * pMsg) 
{
     switch(pMsg->MsgId)
     {
         case WM_PAINT:
             GUI_DrawBitmap(&bmhome32x32,0,0);     
              break;
         default:
              BUTTON_Callback(pMsg);
     }
}

static void _cbDialogDC3MPage1(WM_MESSAGE * pMsg) {
    WM_HWIN hItem;
    int     NCode;
    int     Id;
    
    switch (pMsg->MsgId) {
    case WM_INIT_DIALOG:
        hItem = WM_GetDialogItem(pMsg->hWin, ID_Muti_BUTTON_10);
        BUTTON_SetFont(hItem, GUI_FONT_16B_ASCII);
        BUTTON_SetText(hItem, "Page1");
    
        hItem = WM_GetDialogItem(pMsg->hWin, ID_Muti_BUTTON_10);            
        WM_SetCallback(hItem,_cbMutiButton10);
    
        WM_CreateTimer(pMsg->hWin, ID_Muti_TIMER_10, DC3_Muti1_TimerDelay/10, 0); 
    break;
    
    case WM_PAINT:
        DC3_Muti_Idex = 0;
        GUI_Clear();
        GUI_DrawBitmap(&bmPower_desktop320x240,0 ,0);
        DC3Show_Muti1_TEXT();
    break;   
    
    case WM_TIMER:
        if(DC3_Muti_Idex==0)
        {
            DC3_PowerStatus=1; 
        }
        WM_InvalidateWindow(pMsg->hWin);            
        WM_RestartTimer(pMsg->Data.v, DC3_Muti1_TimerDelay);
    break;     
    
    case WM_NOTIFY_PARENT:
        Id    = WM_GetId(pMsg->hWinSrc);
        NCode = pMsg->Data.v;
        switch(Id) {
        case ID_Muti_BUTTON_10: // Notifications sent by 'Multipage'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                //__nop();                
            break;
            case WM_NOTIFICATION_RELEASED:
                WM_DeleteWindow(pMsg->hWin);
                WM_DeleteWindow(DC3Multi_hWin);
                Create_PowerWindow();               
            break;
            }
        break;  
        }
    break;
        
    default:
        WM_DefaultProc(pMsg);
    break;
    }
}

WM_HWIN CreateWindow_DC3MPage1(void) {
  WM_HWIN hWin;

  hWin = GUI_CreateDialogBox(_aDialogCreateDC3MPage1, GUI_COUNTOF(_aDialogCreateDC3MPage1), _cbDialogDC3MPage1, WM_HBKWIN, 0, 0);
  DC3_Muti1GetInfo=1;
  return hWin;
}

/*************************** Multi Page2 ****************************/
const GUI_ConstString  DC3_apHour[] = {  "00","01","02","03","04","05","06","07","08","09","10","11","12", NULL};    

const GUI_ConstString  DC3_apMin[] = {  "00","05","10","15","20","25","30","35","40","45","50","55",NULL};

static const GUI_WIDGET_CREATE_INFO _aDialogCreateDC3MPage2[] = {
  { WINDOW_CreateIndirect, "Window", ID_Muti_WINDOW_20, 0, 0, 320, 210, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "ReturnButton", ID_Muti_BUTTON_20, 285, 175, 32, 32, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "Power0Switch", ID_Muti_BUTTON_21, 40, 130, 48, 48, 0, 0x0, 0 },
  { LISTWHEEL_CreateIndirect, "Listwheel0", ID_Muti_LISTWHEEL_20, ListWheel_0X0, ListWheel_0Y0, ListWheelX0_Size, ListWheelY0_Size, 0, 0x0, 0 },
  { LISTWHEEL_CreateIndirect, "Listwheel1", ID_Muti_LISTWHEEL_21, ListWheel_1X0, ListWheel_1Y0, ListWheelX0_Size, ListWheelY0_Size, 0, 0x0, 0 },
};

void DC3Show_Muti2_TEXT(void)
{
    char ac[10];
    GUI_SetTextMode(GUI_TM_TRANS);
    GUI_SetTextAlign(GUI_TA_HCENTER | GUI_TA_VCENTER);
    
    GUI_SetFont(GUI_FONT_20B_1);
    GUI_SetColor(GUI_RED);
    GUI_DispStringHCenterAt("DC3" , 30, 20);    
    
    GUI_SetFont(GUI_FONT_COMIC24B_1);
    GUI_SetColor(GUI_YELLOW); 
    GUI_DispStringHCenterAt("min" , (ListWheel_0X0+ListWheelX0_Size)+WheelText_Gap0, ListWheel_0Y0+(ListWheelY0_Size/2));
    GUI_DispStringHCenterAt("sec" , (ListWheel_1X0+ListWheelX0_Size)+WheelText_Gap1, ListWheel_0Y0+(ListWheelY0_Size/2));
    
    GUI_SetFont(GUI_FONT_D32);
    GUI_SetColor(GUI_WHITE);
    sprintf(ac,"%02d:%02d", DC3_ListWheel1_Hr, DC3_ListWheel2_Min); 
    GUI_DispStringHCenterAt(ac , 65, 80);
}

static int Muti2_OwnerDraw(const WIDGET_ITEM_DRAW_INFO * pDrawItemInfo) {
    switch (pDrawItemInfo->Cmd) {
    case WIDGET_ITEM_GET_XSIZE:
    return LISTWHEEL_OwnerDraw(pDrawItemInfo);
    
    case WIDGET_ITEM_GET_YSIZE:
    return LISTWHEEL_OwnerDraw(pDrawItemInfo);
    
    case WIDGET_ITEM_DRAW:
    return LISTWHEEL_OwnerDraw(pDrawItemInfo);
    
    case WIDGET_ITEM_DRAW_BACKGROUND:
    return LISTWHEEL_OwnerDraw(pDrawItemInfo);
    
    case WIDGET_ITEM_DRAW_OVERLAY:
        GUI_SetColor(GUI_RED);
        GUI_DrawHLine(60, 0, 40);
        GUI_DrawHLine(90, 0, 40);
    break;
    
    default:
    return LISTWHEEL_OwnerDraw(pDrawItemInfo);
    }
    return 0;
}

static void _cbMutiButton20(WM_MESSAGE * pMsg) 
{
     switch(pMsg->MsgId)
     {
         case WM_PAINT:
             GUI_DrawBitmap(&bmhome32x32,0,0);     
              break;
         default:
              BUTTON_Callback(pMsg);
     }
}

static void _cbMutiButton21(WM_MESSAGE * pMsg) 
{
     switch(pMsg->MsgId)
     {
         case WM_PAINT:
             GUI_SetAlpha(0xff);
             if(DC3_PowerSW)
             {
                 GUI_DrawBitmap(&bmPowerStop48x48,0,0);
             }
             else  
             {
                 GUI_DrawBitmap(&bmPowerStart48x48,0,0); 
             }                 
              break;
         default:
              BUTTON_Callback(pMsg);
     }
}

static void _cbDialogDC3MPage2(WM_MESSAGE * pMsg) {
    WM_HWIN hItem;
//    S_RTC_TIME_DATA_T sCurTimeDC3;
    LISTWHEEL_Handle ListWheel_Win1;   
    LISTWHEEL_Handle ListWheel_Win2;   
    WM_MESSAGE WheelpMsgInfo;    
    int     NCode;
    int     Id;
    
    switch (pMsg->MsgId) {
    case WM_INIT_DIALOG:
        hItem = WM_GetDialogItem(pMsg->hWin, ID_Muti_BUTTON_20);
        BUTTON_SetFont(hItem, GUI_FONT_16B_ASCII);
        BUTTON_SetText(hItem, "Page2");
    
        hItem = WM_GetDialogItem(pMsg->hWin, ID_Muti_BUTTON_20);            
        WM_SetCallback(hItem,_cbMutiButton20); 

        hItem = WM_GetDialogItem(pMsg->hWin, ID_Muti_BUTTON_21);            
        WM_SetCallback(hItem,_cbMutiButton21);   

        ListWheel_Win1 = WM_GetDialogItem(pMsg->hWin, ID_Muti_LISTWHEEL_20);
        ListWheel_Win2 = WM_GetDialogItem(pMsg->hWin, ID_Muti_LISTWHEEL_21);
        LISTWHEEL_SetText(ListWheel_Win1, DC3_apHour);
        LISTWHEEL_SetText(ListWheel_Win2, DC3_apMin);    
    
        LISTWHEEL_SetTextAlign(ListWheel_Win1, GUI_TA_VCENTER | GUI_TA_HCENTER);
        LISTWHEEL_SetTextAlign(ListWheel_Win2, GUI_TA_VCENTER | GUI_TA_HCENTER);
        LISTWHEEL_SetFont(ListWheel_Win1, GUI_FONT_16B_ASCII);
        LISTWHEEL_SetFont(ListWheel_Win2, GUI_FONT_16B_ASCII);
    
        LISTWHEEL_SetTextColor(ListWheel_Win1, LISTWHEEL_CI_UNSEL, GUI_GRAY); 
        LISTWHEEL_SetTextColor(ListWheel_Win2, LISTWHEEL_CI_UNSEL, GUI_GRAY);   
        LISTWHEEL_SetTextColor(ListWheel_Win1, LISTWHEEL_CI_SEL, GUI_YELLOW); 
        LISTWHEEL_SetTextColor(ListWheel_Win2, LISTWHEEL_CI_SEL, GUI_YELLOW);

        LISTWHEEL_SetBkColor(ListWheel_Win1, LISTWHEEL_CI_UNSEL, GUI_BLACK);
        LISTWHEEL_SetBkColor(ListWheel_Win2, LISTWHEEL_CI_UNSEL, GUI_BLACK);    
        LISTWHEEL_SetBkColor(ListWheel_Win1, LISTWHEEL_CI_SEL, GUI_BLACK);
        LISTWHEEL_SetBkColor(ListWheel_Win2, LISTWHEEL_CI_SEL, GUI_BLACK);
    
        LISTWHEEL_SetSnapPosition(ListWheel_Win1, Wheel_LineHeight*2);
        LISTWHEEL_SetSnapPosition(ListWheel_Win2, Wheel_LineHeight*2);
    
        LISTWHEEL_SetLineHeight(ListWheel_Win1, Wheel_LineHeight);
        LISTWHEEL_SetLineHeight(ListWheel_Win2, Wheel_LineHeight);
    
        LISTWHEEL_SetDeceleration(ListWheel_Win1, 10);    
        LISTWHEEL_SetDeceleration(ListWheel_Win2, 10);

        LISTWHEEL_SetTimerPeriod(ListWheel_Win1, 15);
        LISTWHEEL_SetTimerPeriod(ListWheel_Win2, 15); 

        LISTWHEEL_SetRBorder(ListWheel_Win1, 00);
        LISTWHEEL_SetRBorder(ListWheel_Win2, 00);
        LISTWHEEL_SetLBorder(ListWheel_Win1, 00);
        LISTWHEEL_SetLBorder(ListWheel_Win2, 00); 

        LISTWHEEL_SetSel(ListWheel_Win1,DC3_ListWheel1_Hr);
        LISTWHEEL_SetSel(ListWheel_Win2,DC3_ListWheel2_Min/5);
        
        LISTWHEEL_SetPos(ListWheel_Win1,DC3_ListWheel1_Hr);
        LISTWHEEL_SetPos(ListWheel_Win2,DC3_ListWheel2_Min/5);        

        LISTWHEEL_SetOwnerDraw(ListWheel_Win1, Muti2_OwnerDraw);
        LISTWHEEL_SetOwnerDraw(ListWheel_Win2, Muti2_OwnerDraw);
        
        WM_CreateTimer(pMsg->hWin, ID_Muti_TIMER_20, 500, 0);
    break;
    
    case WM_PAINT:
        DC3_Muti_Idex = 1;
        GUI_SetBkColor(GUI_BLACK);
        GUI_Clear();
        GUI_DrawBitmap(&bmPower_desktop320x240,0 ,0);
        DC3Show_Muti2_TEXT();    
        GUI_SetColor(GUI_RED);
        GUI_DrawHLine(((Wheel_LineHeight*2)+ListWheel_0Y0), ListWheel_0X0+ListWheelX0_Size, ListWheel_1X0);
        GUI_DrawHLine(((Wheel_LineHeight*3)+ListWheel_0Y0), ListWheel_0X0+ListWheelX0_Size, ListWheel_1X0);
        GUI_DrawHLine(((Wheel_LineHeight*2)+ListWheel_0Y0), ListWheel_1X0+ListWheelX0_Size, 310);
        GUI_DrawHLine(((Wheel_LineHeight*3)+ListWheel_0Y0), ListWheel_1X0+ListWheelX0_Size, 310);
    break;  
    
    case WM_TIMER:
        WheelpMsgInfo.MsgId = WM_NOTIFY_PARENT;
        WheelpMsgInfo.Data.v = WM_NOTIFICATION_RELEASED;
        WheelpMsgInfo.hWinSrc = WM_GetDialogItem(pMsg->hWin, ID_Muti_LISTWHEEL_20);
        WM_SendMessage(pMsg->hWin, &WheelpMsgInfo);
        WM_InvalidateWindow(pMsg->hWin);          
        WM_RestartTimer(pMsg->Data.v, 500);
    break;     
    
    case WM_NOTIFY_PARENT:
        Id    = WM_GetId(pMsg->hWinSrc);
        NCode = pMsg->Data.v;
        ListWheel_Win1 = WM_GetDialogItem(WM_GetClientWindow(pMsg->hWin), ID_Muti_LISTWHEEL_20);
        ListWheel_Win2 = WM_GetDialogItem(WM_GetClientWindow(pMsg->hWin), ID_Muti_LISTWHEEL_21);     
        switch(Id) {
        case ID_Muti_BUTTON_20: // Notifications sent by 'Multipage'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                //__nop();                
            break;
            case WM_NOTIFICATION_RELEASED:
                WM_DeleteWindow(pMsg->hWin);
                WM_DeleteWindow(DC3Multi_hWin);
                Create_PowerWindow();                
            break;
            }
        break;
            
        case ID_Muti_BUTTON_21: // Notifications sent by 'Multipage'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                //__nop();                
            break;
            case WM_NOTIFICATION_RELEASED:
                if(DC3_PowerSW)
                {
                    DC3_PowerSW=0;  
//                    DC3_LED =LED_OFF;
                    DC3_PowerStatus=1;  
                    DC3_BackUp_ListWheel1Hr = DC3_RTC_ConHr;   
                    DC3_BackUp_ListWheel2Min = DC3_RTC_ConMin;                                    
                }
                else
                {
//                    RTC_GetDateAndTime(&sCurTimeDC3);
//                    DC3_RTC_BaseHr = sCurTimeDC3.u32Minute;
//                    DC3_RTC_BaseMin = sCurTimeDC3.u32Second;
                    DC3_PowerSW=1;   
//                    DC3_LED =LED_ON;
                    DC3_PowerStatus=1;  
                }
                WM_InvalidateWindow(pMsg->hWin);               
            break;
            }
        break;

        case ID_Muti_LISTWHEEL_20: // Notifications sent by 'Listwheel'
        case ID_Muti_LISTWHEEL_21: // Notifications sent by 'Listwheel'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                //__nop();
            break;

            case WM_NOTIFICATION_RELEASED:
                DC3_ListWheel1_Hr = LISTWHEEL_GetPos(ListWheel_Win1); 
                DC3_ListWheel2_Min = LISTWHEEL_GetPos(ListWheel_Win2) * 5; 
                LISTWHEEL_SetSel(ListWheel_Win1,DC3_ListWheel1_Hr);
                LISTWHEEL_SetSel(ListWheel_Win2,DC3_ListWheel2_Min/5);
                WM_InvalidateWindow(pMsg->hWin);
            break;
            }
        break;

        }
    break;
        
    default:
        WM_DefaultProc(pMsg);
    break;
    }
}

WM_HWIN CreateWindow_DC3MPage2(void) {
  WM_HWIN hWin;

  hWin = GUI_CreateDialogBox(_aDialogCreateDC3MPage2, GUI_COUNTOF(_aDialogCreateDC3MPage2), _cbDialogDC3MPage2, WM_HBKWIN, 0, 0);
  return hWin;
}

/*************************** Multi Page3 ****************************/
static const GUI_WIDGET_CREATE_INFO _aDialogCreateDC3MPage3[] = {
  { WINDOW_CreateIndirect, "Window", ID_Muti_WINDOW_30, 0, 0, 320, 210, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "ReturnButton", ID_Muti_BUTTON_30, 285, 175, 32, 32, 0, 0x0, 0 },
};

static void _cbMutiButton30(WM_MESSAGE * pMsg) 
{
     switch(pMsg->MsgId)
     {
         case WM_PAINT:
             GUI_DrawBitmap(&bmhome32x32,0,0);     
              break;
         default:
              BUTTON_Callback(pMsg);
     }
}

void DC3Draw_SpeedMeter(void)
{
    int i, x, y;
    char ac[10];
    float a;
    GUI_AA_EnableHiRes(); /* Enable high resolution */
    GUI_AA_SetFactor(AA_Factor); /* Set quality factor */
    GUI_SetPenSize( 5 );
    GUI_SetTextMode(GUI_TM_TRANS);
    GUI_SetFont(&GUI_FontComic18B_ASCII);
    GUI_SetColor( GUI_WHITE );
    GUI_AA_DrawArc(SpeedMeterX0*AA_Factor, SpeedMeterY0*AA_Factor, SpeedMeter_rad*AA_Factor, SpeedMeter_rad*AA_Factor, Meter_dregreeS, Meter_dregreeE);
    
    for (i=0; i< 25; i++) 
    {
        float a = (Meter_dregreeS+i*10)*3.1415926/180;
        int x = Meter_Point_X0Y0*cos(a)+SpeedMeterX0;
        int y = Meter_Point_X0Y0*sin(a)+SpeedMeterY0;
        if (i%2 == 0)
            GUI_AA_FillCircle(x*AA_Factor, y*AA_Factor, 2*AA_Factor);
        else
            GUI_AA_FillCircle(x*AA_Factor, y*AA_Factor, 1*AA_Factor);
        if (i%2 == 0) 
        {
            x = Meter_TextNumX0*cos(a)+SpeedMeterX0;
            y = Meter_TextNumY0*sin(a)+SpeedMeterY0;
            if(DC3_CurrnetUnit == 0x00)
                sprintf(ac, "%d", 50*i);
            else if (DC3_CurrnetUnit == 0x01)
                sprintf(ac, "%d", 50*i);
            else if (DC3_CurrnetUnit == 0x02)
                sprintf(ac, "%.1f", 0.5*i);
            GUI_SetTextAlign(GUI_TA_VCENTER);
            GUI_DispStringHCenterAt(ac,x,y);
        }
    }
    GUI_SetFont(&GUI_FontComic24B_ASCII); 
    if(DC3_CurrnetUnit == 0x00)
        GUI_DispStringHCenterAt("uA" , SpeedMeterX0, (SpeedMeterY0+60));
    else if (DC3_CurrnetUnit == 0x01)
        GUI_DispStringHCenterAt("mA" , SpeedMeterX0, (SpeedMeterY0+60));
    else if (DC3_CurrnetUnit == 0x02)
        GUI_DispStringHCenterAt("A" , SpeedMeterX0, (SpeedMeterY0+60));

    GUI_SetPenSize(3);
    GUI_SetColor( GUI_RED );

    a = (DC3_SpeedMeterValue)*3.1415926/180;
    x = Meter_Point_X0Y0*cos(a)+SpeedMeterX0;
    y = Meter_Point_X0Y0*sin(a)+SpeedMeterY0;
    GUI_AA_DrawLine(SpeedMeterX0*AA_Factor, SpeedMeterX0*AA_Factor, x*AA_Factor, y*AA_Factor);
  
    GUI_AA_DisableHiRes(); /* Disable high resolution */
    
    GUI_SetTextAlign(GUI_TA_HCENTER | GUI_TA_VCENTER);
    GUI_SetFont(GUI_FONT_20B_1);
    GUI_SetColor(GUI_RED);
    GUI_DispStringHCenterAt("DC3" , 30, 20); 
}

static void _cbDialogDC3MPage3(WM_MESSAGE * pMsg) {
    WM_HWIN hItem;
    int     NCode;
    int     Id;

    switch (pMsg->MsgId) {
    case WM_INIT_DIALOG:
        hItem = WM_GetDialogItem(pMsg->hWin, ID_Muti_BUTTON_30);
        BUTTON_SetFont(hItem, GUI_FONT_16B_ASCII);
        BUTTON_SetText(hItem, "Page3");
    
        hItem = WM_GetDialogItem(pMsg->hWin, ID_Muti_BUTTON_30);            
        WM_SetCallback(hItem,_cbMutiButton30);   

        WM_CreateTimer(pMsg->hWin, ID_Muti_TIMER_30, 200, 0);    
    break;
    
    case WM_PAINT:
        DC3_Muti_Idex = 2;
        GUI_SetBkColor(GUI_BLUE);
        GUI_Clear();
        GUI_DrawBitmap(&bmPower_desktop320x240,0 ,0);
        DC3Draw_SpeedMeter();
    break;    
    
    case WM_TIMER:
        if(DC3_PowerSW)
        {
            if((DC3_CurrnetUnit == 0x00) || (DC3_CurrnetUnit == 0x01))
            {
                DC3_SpeedMeterValue = (DC3_Currnet/10*2) + Meter_dregreeS;
            }
            else if (DC3_CurrnetUnit == 0x02)
            {
                DC3_SpeedMeterValue = ((DC3_Currnet*10*2)/16) + Meter_dregreeS;
            }
            if(DC3_SpeedMeterValue > Meter_dregreeE) DC3_SpeedMeterValue = Meter_dregreeS;                
        }
        else
        {
            DC3_SpeedMeterValue = Meter_dregreeS;
        }
        if(DC3_Muti_Idex==2)
        {
            DC3_PowerStatus=1; 
        }
        WM_InvalidateWindow(pMsg->hWin);        
        WM_RestartTimer(pMsg->Data.v, 200);
    break;    
    
    case WM_NOTIFY_PARENT:
        Id    = WM_GetId(pMsg->hWinSrc);
        NCode = pMsg->Data.v;
        switch(Id) {
        case ID_Muti_BUTTON_30: // Notifications sent by 'Multipage'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                //__nop();
            break;
            case WM_NOTIFICATION_RELEASED:
                WM_DeleteWindow(pMsg->hWin);
                WM_DeleteWindow(DC3Multi_hWin);
                Create_PowerWindow(); 
            break;
            }
        break; 
        }
    break;
        
    default:
        WM_DefaultProc(pMsg);
    break;
    }
}

WM_HWIN CreateWindow_DC3MPage3(void) {
  WM_HWIN hWin;

  hWin = GUI_CreateDialogBox(_aDialogCreateDC3MPage3, GUI_COUNTOF(_aDialogCreateDC3MPage3), _cbDialogDC3MPage3, WM_HBKWIN, 0, 0);
  return hWin;
}

/*************************** Dialog Window ****************************/
static const GUI_WIDGET_CREATE_INFO _aDialogCreateDC3[] = {
  { WINDOW_CreateIndirect, "Window", ID_WINDOW_0, 0, 0, 320, 240, 0, 0x0, 0 },
  { MULTIPAGE_CreateIndirect, "Multipage", ID_MULTIPAGE_0, 0, 0, 320, 240, 0, 0x0, 0 },
};

static void _cbDialogDC3(WM_MESSAGE * pMsg) {
    WM_HWIN hItem;
    WM_HWIN hWinPage;
    int     NCode;
    int     Id;

    switch (pMsg->MsgId) {
    case WM_INIT_DIALOG:
        hItem = WM_GetDialogItem(pMsg->hWin, ID_MULTIPAGE_0);
        MULTIPAGE_SetTabHeight(hItem, 30);

        MULTIPAGE_SetFont(hItem, &GUI_Font20_ASCII);
        MULTIPAGE_SetTextAlign(hItem, GUI_TA_HCENTER | GUI_TA_VCENTER);
        MULTIPAGE_SetTextColor(hItem, GUI_BLACK, 1);
    
        MULTIPAGE_SetBkColor(hItem, 0xFFFFCC22, MULTIPAGE_CI_ENABLED);
        MULTIPAGE_SetAlign(hItem, MULTIPAGE_ALIGN_BOTTOM | MULTIPAGE_ALIGN_LEFT);

        hWinPage = CreateWindow_DC3MPage1();
        MULTIPAGE_AddEmptyPage(hItem, hWinPage, "Cost");
        MULTIPAGE_SetTabWidth(hItem, 106, 0);

        hWinPage = CreateWindow_DC3MPage2();
        MULTIPAGE_AddEmptyPage(hItem, hWinPage, "Timer");
        MULTIPAGE_SetTabWidth(hItem, 106, 1);
    
        hWinPage = CreateWindow_DC3MPage3();
        MULTIPAGE_AddEmptyPage(hItem, hWinPage, "Current");
        MULTIPAGE_SetTabWidth(hItem, 107, 2);

        MULTIPAGE_SelectPage(hItem, DC3_Muti_Idex);
    break;
    
    case WM_PAINT:
        if(DC3_Muti_Idex ==0)
        {
            GUI_SetBkColor(GUI_BLACK);
        }    
        if(DC3_Muti_Idex ==1)
        {
            GUI_SetBkColor(GUI_BLACK);
        }
        if(DC3_Muti_Idex ==2)
        {
            GUI_SetBkColor(GUI_BLACK);
        }        
        GUI_Clear(); 
    break; 
        
    case WM_NOTIFY_PARENT:
        Id    = WM_GetId(pMsg->hWinSrc);
        NCode = pMsg->Data.v;
        switch(Id) {
        case ID_MULTIPAGE_0: // Notifications sent by 'Multipage'
          switch(NCode) {
          case WM_NOTIFICATION_CLICKED:
                //__nop();
          break;
          case WM_NOTIFICATION_RELEASED:
                //__nop();
          break;
          }
        break;
        }
    break;
        
    default:
        WM_DefaultProc(pMsg);
    break;
    }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       CreateWindow
*/
WM_HWIN CreatePowerWindowDC3(void)
{
  Window_Idex = DC3_WINDOW;
  DC3Multi_hWin = GUI_CreateDialogBox(_aDialogCreateDC3, GUI_COUNTOF(_aDialogCreateDC3), _cbDialogDC3, WM_HBKWIN, 0, 0);
  return DC3Multi_hWin;
}
/*************************** End of file ****************************/
